'
' BASIC blinking demo
'
' this version uses a PASM routine running in another COG
'

' PASM code
' this is "asm shared" because it will run in another COG rather than
' being inline asm for this COG ("asm shared" is like "DAT" in Spin)
' When run, ptra is pointing at 2 longs: the pin to toggle, and
' the number of cycles to delay between toggles

asm shared
entry
    ' read the parameters from HUB memory
    rdlong ledpin, ptra[0]   ' read pin to toggle
    rdlong delay,  ptra[1]   ' read delay in cycles
loop
    drvnot ledpin    ' toggle the pin
    waitx  delay     ' wait
    jmp    #loop     ' go back and do it again

    ' variables
ledpin long 0
delay  long 0

end asm

' parameters for CPU code
dim param(2) as integer

' function to launch a COG to toggle a pin
' "delay" is the delay in milliseconds between toggles
' returns the COG number
function runblink(pin as integer, delay as integer)
  ' convert milliseconds to cycles
  delay = (clkfreq / 1000) * delay
  ' put parameters into HUB ram
  param(0) = pin
  param(1) = delay
  ' start the shared assembly code from "entry"
  ' ptra will be set to point to the start of the param array
  var i = cpu(@entry, @param(0))
  ' wait for COG to start
  waitus(1)
  return i
end function

var a = runblink(56, 500)
var b = runblink(57, 100)
print "started cogs "; a; " and "; b
