'
' simple FlexBASIC file I/O demo
' lets you write some data to a file and read it back
'
' see the end of this file for some caveats

' select one of the next two lines:
'mount "/data", _vfs_open_sdcard()   ' store data on SD card
mount "/data", _vfs_open_host()      ' store data on PC

' check$ will contain the user's response:
'   s to show message, w to write a new one

dim check$ as string

do
  input "show message (s) or write new one (w)"; check$
  if check$ = "s" then
    showmessage
  else if check$ = "w" then
    writemessage
  else
    print "I did not understand your response ("; check$; ")"
  endif
loop

' subroutine to print the contents of the file /data/message.txt
sub showmessage()
  dim msg$ as string
  dim flag as integer
  flag = 0

  ' open the file
  open "/data/message.txt" for input as #2

  ' read data from it
  do
    input #2, msg$
    if msg$ <> "" then
      flag=1         ' record that we printed something
      print msg$
    endif
  loop while msg$ <> ""
  if flag=0 then
    ' no data read
    print " *** no message found"
  end if
  close #2
end sub

' routine to read the user's message and write it to file /data/message.txt
sub writemessage()
  dim msg$ as string
  ' open the file
  open "/data/message.txt" for output as #2
  ' write data to it
  print "enter your message, with a blank line to terminate"
  do
    input msg$
    if msg$ = "" then
      exit do
    endif
    print #2, msg$
  loop
  close #2
end sub

'
' caveats:
' (1) There isn't much error checking yet. FlexBASIC's file functions still need
'     some work to report errors in a clean way; this is coming soon
' (2) Commas aren't handled properly (the FlexBASIC `input` function uses these
'     to delimit fields
'
