'
' demos for some advanced FlexBASIC features
'

' type declaration: "intfunc" is a function returning an integer
type intfunc as function(x as integer) as integer

' closures: this function returns a function which
' adds n to its argument
'

function addn(n as integer) as intfunc
  ' [x :=> x+n] is the shorthand version of a function
  '             with 1 argument x and which returns x+n
  return [x :=>x+n]
end function

var f = addn(1)   ' f(x) should be x+1
var g = addn(5)   ' g(x) should be x+5

' generic functions
' this is a function which swaps two variables of any type T
' "byref" means the variables are passed "by reference"
' so changes in their values are persistent

any(T) sub swap(byref x as T, byref y as T)
  x,y = y,x  ' multiple assignment
end sub

print "original results:       ";
print 3, f(3), g(3)

swap(f, g)

print "after swapping f and g: ";
print 3, f(3), g(3)

